/* filename: def28x.h */
/* By RealSYS	2003/10/23 */

#ifndef	__DEF28X_H
#define	__DEF28X_H

/* define constants */
#define     FALSE	0
#define     TRUE	!FALSE
#define		NULL	(void *)0
#define 	HIGH	1
#define 	LOW		0
#define 	LF		0x0A	// Line feed
#define 	CR		0x0D	// Carrage return

typedef			 char	BOOL;
typedef	unsigned char	BYTE;
typedef	unsigned int	WORD;
typedef	unsigned long	LONG;

#define	NOP		asm("	NOP")
#define	EI		asm("	clrc INTM")
#define	DI		asm("	setc INTM")

#define	HI_BYTE(val)		((val>>8)&0xff)
#define	LO_BYTE(val)		(val&0xff)

#define	BIT_MASK(x)			(1 << (x))
#define GetBit(val, bit)	(((val) & BIT_MASK(bit))>>(bit))
#define	SetBit(val, bit)	((val) |= BIT_MASK(bit))
#define	ClearBit(val, bit)	((val) &= ~BIT_MASK(bit))
#define	ToggleBit(val, bit)	((val) ^=BIT_MASK(bit))

#define	CHK_BIT(x, bit)		((x) & (bit))
#define	SET_BIT(x, bit)		((x) |= (bit))
#define	CLR_BIT(x, bit)		((x) &= ~(bit))
#define	HI_BIT(x, bit)		((x) |= (bit))
#define	LO_BIT(x, bit)		((x) &= ~(bit))
#define	TOGGLE_BIT(x, bit)	((x) ^= (bit))

#define DELAY_1us	asm(" RPT #146 || NOP ");	/* 6.667ns * 150 = 1usec */

#define	XMEM(a)		*(WORD *)(a)
#define	OUT_LED(d)	*(BYTE *)0x80000 = d
#define	OUT_LCD(d)	*(BYTE *)0x80001 = d
#define	IN_KEY		*(BYTE *)0x80000

#endif
